/*
 * fish stiqz.
 *
 * Provides wrappers for malloc fuctions and other unix utilities.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

extern int errno;

void *
xmalloc(size_t size)
{
    void *t_ptr;

    if ((t_ptr = malloc(size)) == NULL)
    {
        fprintf(stderr, "malloc(%d) failed: %s\n", size, strerror(errno));
        exit(EXIT_FAILURE);
    }
    
    return t_ptr;
}

void *
xmemdup(void *ptr, size_t size)
{
    void *t_ptr;

    t_ptr = xmalloc(size);
    memcpy(t_ptr, ptr, size);
    return t_ptr;
}
