/* 
   SMB Auditing Tool
   Copyright (C) Patrik Karlsson 2001
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef CONSTANTS_H
#define CONSTANTS_H


const int WIN_NETBIOSMODE    = 0;
const int WIN2000_NATIVEMODE = 1;


/*
    Password state Constants
*/

const UCHAR SMB_ERR_CHANGE_PASSWORD_NEXT_LOGIN = 0x24;
const UCHAR SMB_ERR_ACCOUNT_DISABLED = 0x72;
const UCHAR SMB_ERR_ACCESS_DENIED = 0x6D;
const UCHAR SMB_ERR_ACCOUNT_LOCKED_OUT = 0x34;

/*
    SMB Command constants
*/

const UCHAR SMB_CMD_SESSIONREQUEST     = -1;
const UCHAR SMB_CMD_LSAOPENPOLICYSETUP = 0x25;
const UCHAR SMB_CMD_NEGPROT            = 0x72;
const UCHAR SMB_CMD_SESSIONSETUP       = 0x73;
const UCHAR SMB_CMD_LOGOFF             = 0x74;
const UCHAR SMB_CMD_TCONX              = 0x75;
const UCHAR SMB_CMD_CREATEANDX         = 0xA2;
const UCHAR SMB_CMD_CLOSE              = 0x04;

/*
    SMB HEADER OFFSETS
*/

const UCHAR SMB_OFF_SESSIONKEY = 30;
const UCHAR SMB_OFF_USERID = 32;
const UCHAR SMB_OFF_TID = 28;
const UCHAR SMB_OFF_PIPEID = 67;

const UCHAR NB_OFF_LENGTH = 0x03;

const UCHAR LSA_PIPE_2[129] = { 0x00, 0x00, 0x00, 0x94, 0xff, 0x53, 0x4d, 0x42,
				0x25, 0x00, 0x00, 0x00, 0x00, 0x08, 0x01, 0x40,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x2b, 0x09,
				0x00, 0x08, 0x01, 0x00, 0x10, 0x00, 0x00, 0x4c,
				0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x4c, 0x00, 0x4c, 0x00, 0x4c, 0x00, 0x02,
				0x00, 0x26, 0x00, 0x00, 0x40, 0x55, 0x00, 0x5c,
				0x50, 0x49, 0x50, 0x45, 0x5c, 0x00, 0x00, 0x00,
				0x05, 0x00, 0x00, 0x03, 0x10, 0x00, 0x00, 0x00,
				0x4c, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,
				0x34, 0x00, 0x00, 0x00, 0x00, 0x00, 0x39, 0x00,
				0x01, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x00,
				0x00, 0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x00,
				0x5c, 0x00, 0x5c, 0x00, 0x00, 0x00, 0x00,
				0x00, 0x02};



#endif



