/* 
   SMB Auditing Tool
   Copyright (C) Patrik Karlsson 2001
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef UTIL_H
#define UTIL_H

#include <string.h>

char *inflate(char *, int);
char *deflate(char *, int);
SMBUSERS *ll_reverseusers(SMBUSERS *);
SMBPWDS *ll_reversepwds(SMBPWDS *);
void ll_freeusers(SMBUSERS *);
void ll_freepwds(SMBPWDS *);
SMBPWDS *ll_addpw(SMBPWDS *, char *);
SMBUSERS *ll_adduser(SMBUSERS *, int, char *);
void ll_writeitems(FILE *, SMBUSERS *, int, int);
char *ucase(UCHAR *);
char *lcase(UCHAR *);
FILE *OpenUserFile(char *);
FILE *OpenPassFile(char *);
FILE *OpenReportFile(char *);
int PreLoadUsers(BRUTEINFO *, FILE *);
int PreLoadPassWords(BRUTEINFO *, FILE *);
int GetNextUser(FILE *, BRUTEINFO *);
char *ProcessPwd(BRUTEINFO *);

#endif
