/**
 * $Id: commands.h,v 1.3 2003/03/13 17:30:45 plasmahh Exp $
 * $Revision: 1.3 $
 * $Author: plasmahh $
 * $Date: 2003/03/13 17:30:45 $
 */

#ifndef __COMMANDS_H
#define __COMMANDS_H

#define CRLF "\r\n"

enum command_type
{
    rfc,	// Command is a rfc type command and awaits an RFC conform
		// return with leading number code, indicating a multiline with
    		// an - after the number
    
    pop,	// A return from a POP3 Command begins either with an OK+ or an
		// ERR-. Sometimes a command may return a multiline answer, in
		// this case the end of a return is indicated by a line with a
		// single ., i.e.  "\r\n.\r\n"

    imapv4,	// A return from an imap server 
};

struct scan_command 
{
    const char * command; // The Command to be send
    char multiline; // 0 if a single line, non-zero otherwise (i.e. when
    		    // multiline answer is expected)
    char replace_digits;
    char replace_hostname;
    char strip_additional;
    char count_disconnected;
    command_type ctype;
};
#else 
#warning Multiple inclusion of commands.h, please check !
#endif
/**
 *$Log: commands.h,v $
 *Revision 1.3  2003/03/13 17:30:45  plasmahh
 *Added some cool stripping stuff
 *Added pop3 scanning
 *
 *Revision 1.2  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.1  2003/01/27 16:55:40  plasmahh
 *ups, forgot it
 *
 */
