/**
 * $Id: mtypes.h,v 1.4 2003/02/25 16:37:28 plasmahh Exp $
 * $Revision: 1.4 $
 * $Author: plasmahh $
 * $Date: 2003/02/25 16:37:28 $
 */

/**
 * This file makes some definitions of the standard types.
 * This is because some architectures implement some things differentely.
 */

#ifndef __MTYPES_H
#define __MTYPES_H

#if defined( __linux__ )
typedef float 		double32;
typedef double 		double64;

typedef signed long 	sint32;
typedef	unsigned long	uint32;
typedef signed long long sint64;
typedef unsigned long long uint64;

typedef	unsigned char	byte8;
typedef signed char	schar8;
typedef unsigned char	uchar8;
typedef char	char8;

typedef signed short	sint16;
typedef unsigned short	uint16;

#elif defined( __sparc__ )

typedef float           double32;
typedef double          double64;

typedef signed long     sint32;
typedef unsigned long   uint32;
typedef signed long long sint64;
typedef unsigned long long uint64;

typedef unsigned char   byte8;
typedef signed char     schar8;
typedef unsigned char   uchar8;
typedef char	char8;

typedef signed short    sint16;
typedef unsigned short  uint16;

#elif defined ( _I386_INT_TYPES_H_ )

typedef float           double32;
typedef double          double64;

typedef signed long     sint32;
typedef unsigned long   uint32;
typedef signed long long sint64;
typedef unsigned long long uint64;

typedef unsigned char   byte8;
typedef signed char     schar8;
typedef unsigned char   uchar8;
typedef char	char8;

typedef signed short    sint16;
typedef unsigned short  uint16;
#endif 

#else
#warning multiple inclusion of mtypes.h please check !
#endif
/**
 *$Log: mtypes.h,v $
 *Revision 1.4  2003/02/25 16:37:28  plasmahh
 *mstring bugfix
 *mstring enhancement
 *
 *Revision 1.3  2002/12/05 19:12:05  plasmahh
 *some fixes
 *
 *Revision 1.2  2002/11/06 20:33:01  plasmahh
 *fixes for bsd
 *
 *Revision 1.1  2002/11/06 19:16:50  plasmahh
 *renamed file
 *
 *Revision 1.2  2002/10/08 15:01:45  plasmahh
 *some changes for compatibility with sun/solaris/sparc
 *
 *RevisIon 1.1  2002/10/01 21:07:27  plasmahh
 *new math stuff
 *
 *Revision 1.1  2002/06/10 10:36:07  plasmahh
 *Added some math classes in design state, not to be compiled
 *
 */
