/**
 * $Id: pop3_commands.h,v 1.10 2003/04/10 20:59:04 plasmahh Exp $
 * $Revision: 1.10 $
 * $Author: plasmahh $
 * $Date: 2003/04/10 20:59:04 $
 */

#ifndef __COMMANDS_H
#include <commands.h>
#endif

static scan_command pop3_cmds[] = {      /*
					  pop3_multiline  
					     replace_digits
				                replace_hostname
				                   strip_additional
				                      count-disconnected		
				 	  */

    { "USER not available" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RSET" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "PASS not available" CRLF		, 0 ,0 ,1 ,0 ,1 ,pop },
    { "USER not_available" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "USER root" CRLF			, 0 ,0 ,1 ,0 ,1 ,pop },
    { "PASS not available" CRLF		, 0 ,0 ,1 ,0 ,1 ,pop },
    { "USER not_available" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "PASS not_available" CRLF		, 0 ,0 ,1 ,0 ,1 ,pop },
    { "APOP 1" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "APOP <RND_STR1> <RND_STR2> <RND_STR3>" CRLF	, 0 ,0 ,1 ,0 ,0 ,pop },
    { "APOP user stuff" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RSET" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },
    { "RSET" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },
    { "STAT" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },
    { "STAT 1" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },

    { "UIDL" CRLF			, 1 ,0 ,1 ,0 ,0 ,pop },
    { "UIDL 90000" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "UIDL 1" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "UIDL kujl" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "UIDL 1 kujl" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },

    { "LIST" CRLF			, 1 ,1 ,1 ,0 ,0 ,pop },
    { "LIST 1 6" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "LIST 1" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },
    { "LIST hempel" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },

    { "RSET" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop },
    { "UNDEFINED" CRLF			, 0 ,0 ,1 ,0 ,1 ,pop },
    
    { "RETR" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RETR 5164534 900" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RETR 5164534" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RETR 1" CRLF			, 1 ,1 ,1 ,0 ,0 ,pop },
    { "RETR mail" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },

    { "DELE" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "DELE 5164534" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "DELE 5164534 kija" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "DELE kija" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    
    { "TOP" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP 516434" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP 516434 10" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP kratz" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP kratz 90" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP 1" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "TOP 1 10" CRLF			, 1 ,1 ,1 ,0 ,0 ,pop },
    { "TOP 1 klo" CRLF			, 1 ,1 ,1 ,0 ,0 ,pop },

    { "NOOP" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "NOOP 1" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "XTND XMIT 900" CRLF		, 0 ,0 ,1 ,0 ,0 ,pop },
    { "XTND XMIT" CRLF			, 0 ,0 ,1 ,0 ,0 ,pop },
    { "." CRLF				, 0 ,0 ,1 ,0 ,0 ,pop },
    { "RSET" CRLF			, 0 ,1 ,1 ,0 ,0 ,pop }, 
    { "QUIT" CRLF			, 0 ,0 ,1 ,1 ,1 ,pop },
    
    { NULL				, 0 ,0 ,1 ,0 ,0 ,pop }
};
// special command ?? XTND XMIT
/**
 *$Log: pop3_commands.h,v $
 *Revision 1.10  2003/04/10 20:59:04  plasmahh
 *schubidu
 *
 *Revision 1.9  2003/04/10 20:18:47  plasmahh
 *small pop3 stripping change
 *
 *Revision 1.8  2003/03/29 17:00:29  plasmahh
 *new features
 *
 *Revision 1.7  2003/03/27 10:58:16  plasmahh
 *new additions to stripping
 *
 *Revision 1.6  2003/03/13 17:30:45  plasmahh
 *Added some cool stripping stuff
 *Added pop3 scanning
 *
 *Revision 1.5  2003/02/25 23:23:46  plasmahh
 *fixed pop3 scanner bug
 *workaround for buggy rfc response servers
 *
 *Revision 1.4  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.3  2003/01/27 16:53:52  plasmahh
 *migrating build system to athlon
 *
 *Revision 1.2  2003/01/07 13:36:21  plasmahh
 *more implementation of the pop3 protocol
 *
 *Revision 1.1  2002/12/19 23:18:22  plasmahh
 *first preliminary working pop3 support
 *changed options structure heavily
 *
 */
