#ifndef __SCANNER_FTP_H
#define __SCANNER_FTP_H

#ifndef __SCANNER_RFC_H
#include "scanner_rfc.h"
#endif

#include "ftp_commands.h"

/**
 * This class implements nearly the same stuff as the smtp class, therefore I
 * will simply use this, but with other fingerpints and command sequencs
 */
  
class scanner_ftp : public scanner_rfc
{
private:
    /// This function will load the conf fingerprints from a predefined file
    bool load_conf_fps( void );
    /// This function will load the return fingerprints from a predefined file
    bool load_return_fps( void );
    /// This function will load the rfc fingerprints from a predefined file
    bool load_rfc_fps( void );
protected:
public:
    virtual ~scanner_ftp();
    /// We need a socket, the debuglevel, if beeing polite, connect & receive timeout
    scanner_ftp(small_socket& sk, debug_level debug, bool pol, long ct, long rt) : scanner_rfc(sk,debug, pol,ct, rt)
	{ 
	    cmd_list = ftp_cmds;
	    cmd_number = sizeof (ftp_cmds) / sizeof(*ftp_cmds);
	}
    /// returns the protocol we are scanning
    inline virtual mstring protocol( void ) { return "FTP"; }
    /// does everything for initialization, returns false in case of error

    /// lookst if the server connected to is really a sserver of searched type
    virtual mstring is_server( void );
    virtual bool scan_special ( long number );
    virtual bool scan_reconnected ( long number );
    virtual bool do_login (const mstring& username, const mstring& password);
};

#endif

