#ifndef __SCANNER_SMTP_H
#define __SCANNER_SMTP_H

#ifndef __SCANNER_RFC_H
#include "scanner_rfc.h"
#endif

#include "smtp_commands.h"

class scanner_smtp : public scanner_rfc
{
private:
    /// This function will load the conf fingerprints from a predefined file
    virtual bool load_conf_fps( void );
    /// This function will load the return fingerprints from a predefined file
    virtual bool load_return_fps( void );
    /// This function will load the rfc fingerprints from a predefined file
    virtual bool load_rfc_fps( void );
    /// genereate a list from comma sperated values here, returns -1 in case of eerror
    sint32 gen_fp_data (fp * cfp, mstring & fp);
    /// checks if the actual fingerprint length is ok
    uint32 check_lenge(uint32, uint32, uint32, bool);

    void printerror(const mstring &, uint32);

    /// This is a dummy function to avoid warning by compiler for unused struct testcmds
    // inline void dummy ( void ) { const char ** dumm = testcmds; dumm++;}
    
protected:
    
public:
    virtual ~scanner_smtp();
    /// We need a socket, the debuglevel, if beeing polite, connect & receive timeout
    scanner_smtp(small_socket& sk, debug_level debug, bool pol, long ct, long rt) : 
	    scanner_rfc(sk,debug, pol,ct, rt)
	    { 
		cmd_list = smtp_cmds; 
		cmd_number = (sizeof (smtp_cmds)) / (sizeof(scan_command));
	    };
    /// returns the protocol we are scanning
    inline virtual mstring protocol( void ) { return "SMTP"; }
    /// lookst if the server connected to is really a sserver of searched type
    virtual mstring is_server( void );
    /// Does the real scan
    virtual bool scan_special( long number );
    virtual bool scan_reconnected( long number );
    
    virtual bool do_login ( );
};

#endif
