/**
 * $Id: smtp_commands.h,v 1.7 2003/03/29 17:00:29 plasmahh Exp $
 * $Revision: 1.7 $
 * $Author: plasmahh $
 * $Date: 2003/03/29 17:00:29 $
 */

#ifndef __COMMANDS_H
#include <commands.h>
#endif

static scan_command smtp_cmds[] = {
    { "EXPN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "EXPN all" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP EXPN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY root" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP VRFY" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP HELO" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP EHLO" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "ATRN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "AUTH" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "AUTH PLAIN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "AUTH CRAM-MD5" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "HELP AUTH" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SOML FROM: test" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "NOOP" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SAML FROM: test" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SEND FROM: test" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL FROM: <RND_USER>" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "DATA" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RCPT TO: root" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL FROM: nobody" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RCPT TO: <RND_USER>@hotmail.com" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL FROM: user" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RCPT TO: <RND_USER>@<RND_HOST>.ar" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VERB" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "TURN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "DATA" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "TURN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "DSN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP DSN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP MAIL" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RCPT" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP RCPT" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "DATA" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP DATA" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "NOOP" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP NOOP" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL test" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "MAIL FROM: test" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RCPT niemand" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "MAIL FROM: ich" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RCPT" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "RCPT TO: niemand" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "DATA" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "ETRN localhost" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY root" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY bin" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VRFY <RND_USER>" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "RSET" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "ONEX " CRLF				, 0, 0, 1, 0, 0, rfc },
    { "TURN" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SOML" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "VERB" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "STARTTLS" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP STARTTLS" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "QUIT" CRLF				, 0, 0, 1, 0, 0, rfc },
    { NULL					, 0, 0, 0, 0, 0, rfc }
};

/**
 *$Log: smtp_commands.h,v $
 *Revision 1.7  2003/03/29 17:00:29  plasmahh
 *new features
 *
 *Revision 1.6  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.5  2003/01/27 16:53:52  plasmahh
 *migrating build system to athlon
 *
 *Revision 1.4  2002/06/11 22:00:43  plasmahh
 *unfortunately had to change fingerprints
 *
 *Revision 1.3  2002/05/27 06:26:16  plasmahh
 *Implemented, tested and fixed fingerprinting. Test Programs generate good fingerprints, only need to put all in a program and generateerror values
 *
 *Revision 1.2  2002/05/23 19:50:04  plasmahh
 *refined include structure.
 *implemented and fixed some parts, still not working
 *BUG !! FIX THIS !!! : multiple definition of some operators, we will never compile !!
 *
 *Revision 1.1  2002/05/13 14:36:42  plasmahh
 *Added new scanner technologies to plug in new scanners in the future
 *
 *Revision 1.3  2002/05/06 21:27:44  plasmahh
 *redesigned the classes a bit...
 *begin  implementing main & static
 *
 *Revision 1.2  2002/04/16 20:12:12  plasmahh
 *Added some new headers
 *
 */
