/**
 * $Id: fp_rfc.cpp,v 1.12 2002/11/05 00:31:10 plasmahh Exp $
 * $Revision: 1.12 $
 * $Author: plasmahh $
 * $Date: 2002/11/05 00:31:10 $
 */
#include "fp_rfc.h"


//fp_rfc::fp_rfc( const fp_rfc& ofp ) : fp(ofp.version,FP_Rfc),maxidx(ofp.maxidx)
//{
//}

fp_rfc::fp_rfc( const mstring& ver ) : fp(ver,FP_Rfc), actual_code(0)/*{{{*/
{
}/*}}}*/

ostream& operator << ( ostream &o, fp_rfc& v)/*{{{*/
{
    bintreeiterator<uint32, bintree<uint32,uint32> > it((bintree<uint32,bintree<uint32,uint32> >&)v);

    o << "VERSION=" << v.version << endl;

    o << "FP_RFC=";
    bool anfang=true;
    for (it.first();it.valid();it.next())
    {
	if ( !anfang )
	{
	    o << ",";
	}
	anfang = false;
	o << it.key();
	bintreeiterator<uint32,uint32> dit(it.data());
	for (dit.first();dit.valid();dit.next())
	{
	    o << "," << dit.data();
	}
    }

    o << endl;
    return o;
}/*}}}*/

void fp_rfc::add_by_code( uint32 code, uint32 sum)/*{{{*/
{
    if ( has_key(code) )
    {
	get_key(code).add(sum,sum);
    }
    else
    {
	bintree<uint32,uint32> bt;
	bt.add(sum,sum);
	bintree<uint32,bintree<uint32,uint32> >::add(code,bt);
    }

}/*}}}*/

void fp_rfc::add( unsigned long fp)/*{{{*/
{
    if ( fp < 1000)
    {
	actual_code = fp;
    }
    else if ( actual_code != 0 )
    {
	add_by_code( actual_code, fp );
    }
}/*}}}*/

void fp_rfc::add ( const mstring& ret)/*{{{*/
{
    uint32 code;
    uint32 cs;
    code = strtoul(ret,NULL,10);
    cs = ret.checksum_sum() + 1000;
    add_by_code(code,cs);
    
}/*}}}*/

unsigned long fp_rfc::gen_error( fp_rfc& v)/*{{{*/
{
uint32 min_dif=1000000;
uint32 dif=0;


    bintreeiterator<uint32,bintree<uint32,uint32> > bit(v);

    for ( bit.first(); bit.valid(); bit.next() ) // Go through all nodes of the generated fp : v
    {
	if (has_key(bit.key())) // If we self have the same key, go and calculate error
	{
//	    cout << "WE HAVE THE RFC CODE : " << bit.key() << endl;
	    bintreeiterator<uint32,uint32> dit(get_key(bit.key())); // Create an iterator out of all the items in our node.
	    bintreeiterator<uint32,uint32> kit(bit.data()); // An iterator of all the items in the generated node.
	    for (kit.first();kit.valid();kit.next())
	    {
		min_dif = 10000000;
		for (dit.first();dit.valid();dit.next())
		{
		    dif = (uint32)abs((sint32)dit.data() - (sint32)kit.data());
//		    cout << "DIFFERENZ : " << dif << endl;
		    if ( dif < min_dif)
		    {
			min_dif = dif;
		    }
		}
		error += min_dif;
//		cout << "SAVING ERROR VALUE : " << error << endl;
	    }
	}
    }
//    cout << "THIS IS THE ERROR VALUE : " << error << endl;
    /*
for (unsigned int idx=0;idx < maxidx; idx++)
  {
  if ( end[idx] ==0 || v.end[idx] == 0) continue;
  dif = end[idx] - v.end[idx];
  if ( dif > 0 )
    error += dif;
  else
    error -= dif;
  }*/
return error;
}/*}}}*/

/**
 *$Log: fp_rfc.cpp,v $
 *Revision 1.12  2002/11/05 00:31:10  plasmahh
 *fixed rfc fingerprinting
 *
 *Revision 1.11  2002/11/04 23:45:52  plasmahh
 *first addition, implementation and changes for ftp fingerprinting
 *rfc fp fix still mising !
 *
 *Revision 1.10  2002/11/03 23:09:42  plasmahh
 *fixed new rfc fingerptinting, and began collecting fingerprints for it
 *
 *Revision 1.9  2002/11/03 22:25:56  plasmahh
 *new stuff for better rfc fingerprinting and preperation for ftp support... other protocolls might follow
 *
 *Revision 1.8  2002/10/21 08:38:29  plasmahh
 *begin cleanup and structure changes for smtpmap 0.8-stable
 *
 *Revision 1.7  2002/06/11 22:00:44  plasmahh
 *unfortunately had to change fingerprints
 *
 *Revision 1.6  2002/06/11 21:39:31  plasmahh
 *improved reconnection behaviour
 *
 *Revision 1.5  2002/06/11 18:23:52  plasmahh
 *reverified fingerprints
 *
 *Revision 1.4  2002/06/10 22:10:35  plasmahh
 *first partly working fingerprinting, moving to BETA state
 *
 *Revision 1.3  2002/06/09 21:22:39  plasmahh
 *lots of changes
 *some slight fingerprint changes, also in constructor
 *scanner changes and fixes in constructor
 *read fixes
 *test programs fixes, no more segfaults
 *new TODO
 *
 *Revision 1.2  2002/05/27 06:26:16  plasmahh
 *Implemented, tested and fixed fingerprinting. Test Programs generate good fingerprints, only need to put all in a program and generateerror values
 *
 *Revision 1.1  2002/05/23 22:37:55  plasmahh
 *fixed small things in scanner
 *split fps into .cpp files, because of linker errors in operators
 *
 */
