/**
 * $Id: scanner_smtp.cpp,v 1.32 2003/03/29 17:00:29 plasmahh Exp $
 * $Revision: 1.32 $
 * $Author: plasmahh $
 * $Date: 2003/03/29 17:00:29 $
 */

#include "scanner_smtp.h"

scanner_smtp::~scanner_smtp()/*{{{*/
{
}/*}}}*/

bool scanner_smtp::load_rfc_fps (void)/*{{{*/
{
    return load_fp("smtp-fingerprints-rfc","FP_RFC",FP_Rfc,false);
}/*}}}*/

bool scanner_smtp::load_return_fps (void)/*{{{*/
{
    return load_fp("smtp-fingerprints-return","FP_RETURN",FP_Return,true);
}/*}}}*/

bool scanner_smtp::load_conf_fps (void)/*{{{*/
{
    return load_fp("smtp-fingerprints-conf","FP_CONF",FP_Conf,true);
}/*}}}*/

bool scanner_smtp::scan_special( long number )
{
    if (number == 1)
    {
	do_login();
    }
    return true;
}

bool scanner_smtp::scan_reconnected( long number )
{
    if ( number > 1 )
    {
	do_login();
    }
    return true;
}


mstring scanner_smtp::is_server (void)/*{{{*/
{
    mstring banner; 
    // connect to target
    if (debuglevel > 2)
    {
	cout << "scanner_smtp calls Connect ( " << target_host << ")" << endl;
    }

    if ( !  sock.Connect (target_host, target_port, conn_timeout) )
    {
//	cout << "Could not connect to  host, aborting scan ! " << endl;
//	cout << "Reason : " ;
	return sock.GetLastErrorMsg();
    }

    banner = get_rfc_answer();
    sock.Disconnect();
    banner = banner.substring(5,0);
    int r = banner.lsearch("\n") - 1;
    if ( r <= 1)
    {
	banner = banner.substring(0,r);
    }
    banner = banner.strip_whitespaces();
    banner = "\nPossible SMTP-Server : " + banner + "\n";
    return banner;
}/*}}}*/

bool scanner_smtp::do_login ( )/*{{{*/
{ 
    mstring answer;
    mstring ehlo;
    mstring hostname;

    hostname = small_socket::get_hostname();
    ehlo.format("EHLO %s\r\n",(const char8*)hostname); 

    if ( debuglevel > 1 )
    {
	cout << "Logging in to SMTP Server..." << endl;
	cout << "Connection Data : " << endl;
	cout << "port "   << sock.get_port () << endl;
	cout << "socket " << sock.get_fd ()   << endl;
	cout << "target " << sock.get_peer () << endl;

	cout << "SEND " << ehlo;
    }

    sock.Send ((mstring)"EHLO myhost.domain.com\r\n",recv_timeout);
    answer = get_rfc_answer();
    if ( debuglevel > 1 )
    {
	cout << "RECV \"" << answer << "\""<<endl;
    }
    return true;
}/*}}}*/

/**
 *$Log: scanner_smtp.cpp,v $
 *Revision 1.32  2003/03/29 17:00:29  plasmahh
 *new features
 *
 *Revision 1.31  2003/02/25 19:49:29  plasmahh
 *Ok, lets release ;)
 *
 *Revision 1.30  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.29  2002/11/25 23:33:35  plasmahh
 *changed a bit stuff and new fingerprints and and and ;)
 *
 *Revision 1.28  2002/11/05 18:34:10  plasmahh
 *beta release stuff
 *
 *Revision 1.27  2002/11/04 23:45:52  plasmahh
 *first addition, implementation and changes for ftp fingerprinting
 *rfc fp fix still mising !
 *
 *Revision 1.26  2002/11/03 22:25:58  plasmahh
 *new stuff for better rfc fingerprinting and preperation for ftp support... other protocolls might follow
 *
 *Revision 1.25  2002/10/21 08:38:29  plasmahh
 *begin cleanup and structure changes for smtpmap 0.8-stable
 *
 *Revision 1.24  2002/10/16 23:06:17  plasmahh
 *new function for reading fingerprints from file
 *fixes some stuff
 *
 *Revision 1.23  2002/10/01 20:59:02  plasmahh
 *some new structures, to maintain multiple protocols bette
 *
 *Revision 1.22  2002/08/12 13:13:05  plasmahh
 *removed some memory leaks
 *
 *Revision 1.21  2002/08/08 21:52:59  plasmahh
 *better debug
 *
 *Revision 1.20  2002/08/08 21:47:28  plasmahh
 *more debug
 *
 *Revision 1.19  2002/07/24 18:06:47  plasmahh
 *some slight fixes
 *fingerprint changes and cleanups
 *default value changes
 *
 *Revision 1.18  2002/06/20 20:37:01  plasmahh
 *new fingerprints
 *fixed correct fingerprinting on multiple hosts
 *
 *Revision 1.17  2002/06/18 13:42:39  plasmahh
 *fixed timeout behaviour
 *new fingerprints added
 *improved documentation
 *
 *Revision 1.16  2002/06/17 12:23:48  plasmahh
 *fixed timeout bugs
 *
 *Revision 1.14  2002/06/12 23:05:07  plasmahh
 *New fingerprints
 *
 *Revision 1.13  2002/06/11 21:39:31  plasmahh
 *improved reconnection behaviour
 *
 *Revision 1.12  2002/06/11 21:01:53  plasmahh
 *forgot debug messages
 *
 *Revision 1.11  2002/06/11 20:57:38  plasmahh
 *hopefully fixed "hanging" bug
 *
 *Revision 1.10  2002/06/11 20:04:15  plasmahh
 *fixed bad connection behaviour bug
 *
 *Revision 1.9  2002/06/11 18:54:35  plasmahh
 *fixed timeout behaviour, need only to fix reconnects...
 *new fingerprint
 *
 *Revision 1.8  2002/06/11 18:23:53  plasmahh
 *reverified fingerprints
 *
 *Revision 1.7  2002/06/09 21:22:39  plasmahh
 *lots of changes
 *some slight fingerprint changes, also in constructor
 *scanner changes and fixes in constructor
 *read fixes
 *test programs fixes, no more segfaults
 *new TODO
 *
 *Revision 1.6  2002/05/29 12:10:35  plasmahh
 *hm, ja... dont know ;)
 *
 *Revision 1.5  2002/05/27 06:26:17  plasmahh
 *Implemented, tested and fixed fingerprinting. Test Programs generate good fingerprints, only need to put all in a program and generateerror values
 *
 *Revision 1.4  2002/05/23 22:37:55  plasmahh
 *fixed small things in scanner
 *split fps into .cpp files, because of linker errors in operators
 *
 *Revision 1.3  2002/05/23 19:50:04  plasmahh
 *refined include structure.
 *implemented and fixed some parts, still not working
 *BUG !! FIX THIS !!! : multiple definition of some operators, we will never compile !!
 *
 *Revision 1.2  2002/05/16 23:32:12  plasmahh
 *Added fingerprint reading, first version needs to be heavily tested !
 *
 *Revision 1.1  2002/05/14 16:31:59  plasmahh
 *implementing new scanner structure, that will be   e xtendible
 *
 */
