#include <stdio.h>
#include <stdarg.h>

int verbose_level = 0;

/* log_msg messages that should be logged. */
void log_msg(const char *fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);
    fprintf(stderr, "log_msg: %s\n", buf);
	fflush(stderr);
}


/* Error messages that should be logged. */
void error(const char *fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);
    fprintf(stderr, "error: %s\n", buf);
	fflush(stderr);
}

/* Fatal messages that should be logged. */
void fatal(const char *fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);
	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);
 	fprintf(stderr, "fatal: %s\n", buf);
	fflush(stderr);
	fflush(stdout);
	exit(1);
}


/* dump_data messages that should be logged. */
void dump(const char *fmt, ...)
{
	char buf[1024];
	va_list args;
	va_start(args, fmt);

	vsnprintf(buf, sizeof(buf), fmt, args);
	va_end(args);
	fprintf(stdout, "%s", buf);
	fflush(stdout);
}

void verbose(int level, const char *fmt, ...)
{
	if (verbose_level >= level) {
		va_list args;
		va_start(args, fmt);
		dump(fmt, args);
		va_end(args);
	}
}


